﻿var list = [];

main();

function main() {
	try {
		var doc = app.activeDocument;
		var layers = doc.layers;	
		getLayersList(layers);
		var str = list.join("\r");
		
		if (str != doc.info.instructions) {
			doc.info.instructions = str;
		}
		
		if (!doc.saved) {
			doc.save();
		}
	}
	catch(err) {
		//$.writeln(err.message + ", line: " + err.line);
	}
}

function getLayersList(layers) {
	var layer, groupsList, tmp, kind;
	
	for (var i = 0; i < layers.length; i++) {
		layer = layers[i];
		if (layer.visible) {
			if (layer.typename == "LayerSet") { // a group
				getLayersList(layer.layers); // get nested layers
			}
			else { // a layer
				// get the hierarchy of all groups				
				tmp = layer.parent;
				groupsList = [];

				while (tmp.typename == "LayerSet") {
					groupsList.push(tmp.name);
					tmp = tmp.parent;
				}
			
				groupsList.reverse();
				var str = groupsList.join(" - ");
				kind = String(layer.kind).replace(/^LayerKind\./, "");
				kind = kind.substr(0, 1) + kind.substr(1).toLowerCase();
				list.push((str + " - " + layer.name + " (" + kind + ")").replace(/^\s\-\s/, "")); // replace "space-hyphen-space" at start if not in a group
			}
		} // end if visible
	} // end for
}